// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'HTMLFlds.pas' rev: 5.00

#ifndef HTMLFldsHPP
#define HTMLFldsHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <HTTPApp.hpp>	// Pascal unit
#include <HTMLCommon.hpp>	// Pascal unit
#include <Db.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Htmlflds
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum THTMLPrefix { NamePrefix, ValuePrefix };
#pragma option pop

typedef Set<THTMLPrefix, NamePrefix, ValuePrefix>  THTMLPrefixes;

class DELPHICLASS THTMLBaseField;
class PASCALIMPLEMENTATION THTMLBaseField : public Db::TStringField 
{
	typedef Db::TStringField inherited;
	
private:
	AnsiString fNameFlds;
	AnsiString fValFlds;
	AnsiString fCheckField;
	AnsiString HTMLTag;
	Htmlcommon::TGetStrEvent fOnGetName;
	Htmlcommon::TGetStrEvent fOnGetValue;
	Htmlcommon::TGetChecked fOnGetChecked;
	Classes::TStringList* FCustomParams;
	THTMLPrefixes FPrefixes;
	void __fastcall SetCustomParams(const Classes::TStringList* Value);
	void __fastcall SetValFlds(const AnsiString Value);
	
protected:
	virtual AnsiString __fastcall GetStrFromFields(AnsiString flds, bool AsParam);
	#pragma option push -w-inl
	/* virtual class method */ virtual void __fastcall CheckTypeSize(int Value) { CheckTypeSize(__classid(THTMLBaseField)
		, Value); }
	#pragma option pop
	/*         class method */ static void __fastcall CheckTypeSize(TMetaClass* vmt, int Value);
	virtual AnsiString __fastcall GetAsString();
	virtual int __fastcall GetDataSize(void);
	virtual int __fastcall GetDefaultWidth(void);
	HIDESBASE virtual AnsiString __fastcall GetValue();
	virtual AnsiString __fastcall GetNameFromFields(bool AsParam);
	virtual AnsiString __fastcall GetValFromFields(bool AsParam);
	virtual AnsiString __fastcall GetCheckedFromFields(AnsiString htmlname, AnsiString htmlval);
	virtual void __fastcall SetAsString(const AnsiString Value);
	virtual void __fastcall SetFieldKind(Db::TFieldKind Value);
	AnsiString __fastcall GetParams(char Sep);
	__property AnsiString HTMLNameFields = {read=fNameFlds, write=fNameFlds};
	__property AnsiString HTMLValueFields = {read=fValFlds, write=SetValFlds};
	__property AnsiString HTMLCheckField = {read=fCheckField, write=fCheckField};
	__property Htmlcommon::TGetStrEvent OnGetHTMLName = {read=fOnGetName, write=fOnGetName};
	__property Htmlcommon::TGetStrEvent OnGetHTMLValue = {read=fOnGetValue, write=fOnGetValue};
	__property Htmlcommon::TGetChecked OnGetHTMLChecked = {read=fOnGetChecked, write=fOnGetChecked};
	__property Classes::TStringList* HTMLCustomParams = {read=FCustomParams, write=SetCustomParams};
	
public:
	__fastcall virtual THTMLBaseField(Classes::TComponent* AOwner);
	__fastcall virtual ~THTMLBaseField(void);
	__property THTMLPrefixes Prefixes = {read=FPrefixes, nodefault};
	
__published:
	__property Size  = {stored=false, default=0};
	__property FieldKind  = {stored=false, default=1};
};


class DELPHICLASS THTMLCheckBoxField;
class PASCALIMPLEMENTATION THTMLCheckBoxField : public THTMLBaseField 
{
	typedef THTMLBaseField inherited;
	
public:
	__fastcall virtual THTMLCheckBoxField(Classes::TComponent* AOwner);
	
__published:
	__property HTMLNameFields ;
	__property HTMLCheckField ;
	__property HTMLValueFields ;
	__property OnGetHTMLName ;
	__property OnGetHTMLChecked ;
public:
	#pragma option push -w-inl
	/* THTMLBaseField.Destroy */ inline __fastcall virtual ~THTMLCheckBoxField(void) { }
	#pragma option pop
	
};


class DELPHICLASS THTMLEditField;
class PASCALIMPLEMENTATION THTMLEditField : public THTMLBaseField 
{
	typedef THTMLBaseField inherited;
	
private:
	int FSize;
	int FMaxChar;
	
protected:
	virtual AnsiString __fastcall GetValue();
	
public:
	__fastcall virtual THTMLEditField(Classes::TComponent* AOwner);
	
__published:
	__property HTMLNameFields ;
	__property HTMLValueFields ;
	__property int HTMLSize = {read=FSize, write=FSize, nodefault};
	__property int HTMLMaxChar = {read=FMaxChar, write=FMaxChar, nodefault};
	__property OnGetHTMLName ;
	__property OnGetHTMLValue ;
public:
	#pragma option push -w-inl
	/* THTMLBaseField.Destroy */ inline __fastcall virtual ~THTMLEditField(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TWrapKind { wkDefault, wkOff, wkVirtual, wkPhysical };
#pragma option pop

class DELPHICLASS THTMLMemoField;
class PASCALIMPLEMENTATION THTMLMemoField : public THTMLBaseField 
{
	typedef THTMLBaseField inherited;
	
private:
	int FSize;
	int FLines;
	TWrapKind FWrapKind;
	
protected:
	virtual AnsiString __fastcall GetValue();
	
__published:
	__property HTMLNameFields ;
	__property HTMLValueFields ;
	__property int HTMLSize = {read=FSize, write=FSize, nodefault};
	__property int HTMLLines = {read=FLines, write=FLines, nodefault};
	__property TWrapKind HTMLWrapKind = {read=FWrapKind, write=FWrapKind, default=0};
	__property OnGetHTMLName ;
	__property OnGetHTMLValue ;
public:
	#pragma option push -w-inl
	/* THTMLBaseField.Create */ inline __fastcall virtual THTMLMemoField(Classes::TComponent* AOwner) : 
		THTMLBaseField(AOwner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* THTMLBaseField.Destroy */ inline __fastcall virtual ~THTMLMemoField(void) { }
	#pragma option pop
	
};


class DELPHICLASS THTMLRadioField;
class PASCALIMPLEMENTATION THTMLRadioField : public THTMLBaseField 
{
	typedef THTMLBaseField inherited;
	
public:
	__fastcall virtual THTMLRadioField(Classes::TComponent* AOwner);
	
__published:
	__property HTMLNameFields ;
	__property HTMLValueFields ;
	__property HTMLCheckField ;
	__property OnGetHTMLValue ;
	__property OnGetHTMLChecked ;
public:
	#pragma option push -w-inl
	/* THTMLBaseField.Destroy */ inline __fastcall virtual ~THTMLRadioField(void) { }
	#pragma option pop
	
};


class DELPHICLASS THTMLTextField;
class PASCALIMPLEMENTATION THTMLTextField : public THTMLBaseField 
{
	typedef THTMLBaseField inherited;
	
private:
	Htmlcommon::THTMLTextAttributes* FHTMLTextAttributes;
	void __fastcall SetHTMLTextAttributes(const Htmlcommon::THTMLTextAttributes* Value);
	
protected:
	virtual AnsiString __fastcall GetValue();
	
public:
	__fastcall virtual THTMLTextField(Classes::TComponent* AOwner);
	__fastcall virtual ~THTMLTextField(void);
	
__published:
	__property HTMLValueFields ;
	__property Htmlcommon::THTMLTextAttributes* HTMLTextAttributes = {read=FHTMLTextAttributes, write=SetHTMLTextAttributes
		};
	__property OnGetHTMLValue ;
};


class DELPHICLASS THTMLImageField;
class PASCALIMPLEMENTATION THTMLImageField : public THTMLBaseField 
{
	typedef THTMLBaseField inherited;
	
private:
	int fw;
	int fh;
	Httpapp::TCustomWebDispatcher* fdisp;
	AnsiString fImgField;
	AnsiString fKeyFields;
	Htmlcommon::THTMLImageType FImgType;
	bool FUseInternalHandling;
	Htmlcommon::TInternalImageHandler* FInternalHandler;
	Classes::TStringList* FHTMLSrcParams;
	Httpapp::THTTPMethodEvent FOnGetImageAction;
	AnsiString FTable;
	Htmlcommon::TJpegQuality FJpegQuality;
	bool FTestInternalHandling;
	void __fastcall SetUseInternalHandling(const bool Value);
	void __fastcall TryInit(void);
	void __fastcall SetImgField(const AnsiString Value);
	void __fastcall SetHTMLSrcParams(const Classes::TStringList* Value);
	void __fastcall SetTable(const AnsiString Value);
	void __fastcall SetTestInternalHandling(const bool Value);
	
protected:
	virtual AnsiString __fastcall GetValue();
	virtual void __fastcall Loaded(void);
	virtual void __fastcall SetDataSet(Db::TDataSet* ADataSet);
	
public:
	__fastcall virtual THTMLImageField(Classes::TComponent* AOwner);
	__fastcall virtual ~THTMLImageField(void);
	
__published:
	__property int HTMLWidth = {read=fw, write=fw, nodefault};
	__property int HTMLHeight = {read=fh, write=fh, nodefault};
	__property HTMLNameFields ;
	__property HTMLValueFields ;
	__property AnsiString HTMLImageField = {read=fImgField, write=SetImgField};
	__property AnsiString HTMLImageTable = {read=FTable, write=SetTable};
	__property OnGetHTMLName ;
	__property OnGetHTMLValue ;
	__property AnsiString HTMLKeyFields = {read=fKeyFields, write=fKeyFields};
	__property Httpapp::TCustomWebDispatcher* HTMLDispatcher = {read=fdisp, write=fdisp};
	__property Htmlcommon::THTMLImageType HTMLImageType = {read=FImgType, write=FImgType, default=0};
	__property bool UseInternalHandling = {read=FUseInternalHandling, write=SetUseInternalHandling, nodefault
		};
	__property Classes::TStringList* HTMLSrcParams = {read=FHTMLSrcParams, write=SetHTMLSrcParams};
	__property Httpapp::THTTPMethodEvent OnGetImageAction = {read=FOnGetImageAction, write=FOnGetImageAction
		};
	__property Htmlcommon::TJpegQuality JpegQuality = {read=FJpegQuality, write=FJpegQuality, default=50
		};
	__property bool TestInternalHandling = {read=FTestInternalHandling, write=SetTestInternalHandling, 
		stored=false, nodefault};
};


class DELPHICLASS THTMLComboField;
class PASCALIMPLEMENTATION THTMLComboField : public THTMLBaseField 
{
	typedef THTMLBaseField inherited;
	
private:
	AnsiString varSelection;
	Db::TDataSet* fdataset;
	AnsiString fListFields;
	AnsiString fValFields;
	Htmlcommon::TGetChecked fOnGetChecked;
	bool varEmpty;
	int FHTMLSize;
	Classes::TStrings* FHTMLStaticOptions;
	void __fastcall SetHTMLStaticOptions(const Classes::TStrings* Value);
	void __fastcall SetHTMLDataSet(const Db::TDataSet* Value);
	
protected:
	virtual AnsiString __fastcall GetValue();
	
public:
	__fastcall virtual THTMLComboField(Classes::TComponent* AOwner);
	__fastcall virtual ~THTMLComboField(void);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	
__published:
	__property Db::TDataSet* HTMLOptionDataSet = {read=fdataset, write=SetHTMLDataSet};
	__property AnsiString HTMLVisibleFields = {read=fListFields, write=fListFields};
	__property bool OneEmpty = {read=varEmpty, write=varEmpty, nodefault};
	__property AnsiString HTMLSelection = {read=varSelection, write=varSelection};
	__property Htmlcommon::TGetChecked OnGetChecked = {read=fOnGetChecked, write=fOnGetChecked};
	__property Classes::TStrings* HTMLStaticOptions = {read=FHTMLStaticOptions, write=SetHTMLStaticOptions
		};
	__property int HTMLSize = {read=FHTMLSize, write=FHTMLSize, nodefault};
	__property HTMLNameFields ;
	__property HTMLValueFields ;
	__property OnGetHTMLName ;
	__property OnGetHTMLValue ;
};


class DELPHICLASS THTMLProducerField;
class PASCALIMPLEMENTATION THTMLProducerField : public THTMLBaseField 
{
	typedef THTMLBaseField inherited;
	
private:
	Httpapp::TCustomContentProducer* FHTMLProducer;
	
protected:
	virtual AnsiString __fastcall GetValue();
	
public:
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	
__published:
	__property Httpapp::TCustomContentProducer* HTMLProducer = {read=FHTMLProducer, write=FHTMLProducer
		};
public:
	#pragma option push -w-inl
	/* THTMLBaseField.Create */ inline __fastcall virtual THTMLProducerField(Classes::TComponent* AOwner
		) : THTMLBaseField(AOwner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* THTMLBaseField.Destroy */ inline __fastcall virtual ~THTMLProducerField(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Htmlflds */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Htmlflds;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// HTMLFlds
