unit RegNewCgi;

interface

uses DB, HTTPApp;

procedure Register;

//{$DEFINE MIDCOMP}

implementation

uses classes, dsgnintf, PropEdt,
  HTMLBase, HTMLFlds, HTMLCommon
{$IFDEF MIDCOMP}
  ,midcomps, webcomp
{$ENDIF}
;

procedure Register;
begin

  RegisterFields([THTMLEditField,THTMLCheckBoxField,THTMLRadioField,
    THTMLImageField,THTMLMemoField,THTMLTextField,THTMLComboField]);

  RegisterComponents(GroupName, [THTMLProducer,THTMLHidden,
    THTMLStatic,THTMLImage,THTMLCombo,THTMLMultiPage, THTMLDBField]);

{$IFDEF MIDCOMP}
  RegisterWebComponents([THTMLInQuery]);
{$ENDIF}

  RegisterPropertyEditor(TypeInfo(string), THTMLBaseField, 'HTMLNameFields', TFieldsProperty);
  RegisterPropertyEditor(TypeInfo(string), THTMLBaseField, 'HTMLValueFields', TFieldsProperty);
  RegisterPropertyEditor(TypeInfo(string), THTMLBaseField, 'HTMLCheckField', TFieldProperty);

  //RegisterPropertyEditor(TypeInfo(string), THTMLBase, 'HTMLCustomTag', THTMLTagProperty);

  RegisterPropertyEditor(TypeInfo(string), THTMLImageField, 'HTMLImageField', TFieldProperty);
  RegisterPropertyEditor(TypeInfo(string), THTMLImage, 'HTMLImageField', TFieldProperty);

  RegisterPropertyEditor(TypeInfo(string), THTMLImageField, 'HTMLKeyFields', TKeyFieldsProperty);
  RegisterPropertyEditor(TypeInfo(string), THTMLImage, 'HTMLKeyFields', TKeyFieldsProperty);

  RegisterPropertyEditor(TypeInfo(string), THTMLDBField, 'Field', TFieldsProperty);

  RegisterPropertyEditor(TypeInfo(string), THTMLCombo, 'HTMLVisibleFields', TFieldsProperty);
  RegisterPropertyEditor(TypeInfo(string), THTMLComboField, 'HTMLVisibleFields', TFieldsProperty);
  RegisterPropertyEditor(TypeInfo(string), THTMLCombo, 'HTMLValueFields', TFieldsProperty);

  RegisterPropertyEditor(TypeInfo(THTMLFontSize), THTMLTextAttributes, 'HTMLFontSize', THTMLFontSizeProperty);

  RegisterPropertyEditor(TypeInfo(TStrings),
    THTMLProducer, 'CustomTags', TCustomTagsProperty);

  RegisterPropertiesInCategory(TNewCGIPropCategory,THTMLBase,
    ['AfterGetContent','BeforeGetContent',
    'HTML*',//general
    'OnGetChecked','OneEmpty',//combo
    'DataSet','Field',//DBField, Image
    'Dispatcher','OnGetImage*','UseInternalHandling','TestInternalHandling',
    'JpegQuality'//Image
    ]);
  RegisterPropertiesInCategory(TNewCGIPropCategory,THTMLMultiPage,
    ['Num*','PageNumVar','OnPrepare*','OnGet*']);//MultiPage
  RegisterPropertiesInCategory(TNewCGIPropCategory,THTMLProducer,
    ['CustomTags']);//HTMLProducer

  //Fields
  RegisterPropertiesInCategory(TNewCGIPropCategory,THTMLBaseField,[
    'HTML*','OnGetHTML*',//general
    'OnGetChecked','OneEmpty',//combo
    'UseInternalHandling','TestInternalHandling',
    'OnGetImage*','JpegQuality'//Image
    ]);
end;

initialization
finalization
  UnRegisterClasses([THTMLEditField,THTMLCheckBoxField,THTMLRadioField,
    THTMLImageField,THTMLMemoField,THTMLTextField]);
{$IFDEF MIDCOMP}
  UnRegisterWebComponents([THTMLInQuery]);
{$ENDIF}
end.
